<?php

include './core.php';

checkAuth("CA");

cabecera (4);

$command = $_POST['request_command'];
$errorCode = "a0";

switch ($command) {

   default:
      echo "<h1 class='title'>Selecci&oacute;n de fichero de importaci&oacute;n de solicitudes</h1>\n";

      echo "<form method='post' action='data_import.php' enctype='multipart/form-data' name='request_import_selfile'>
      <div id='tbox'>
        <h3 class='head_a2b1'>Importaci&oacute;n</h3>
        <div id='tbox_data_a1'>
          <div id='trow'>
            <div id='tname'>Fichero XML:</div>
            <div id='tvalue'><input type='file' name='csrFile' size='35'></div>
          </div>
          <div id='trow'>
            <div id='tvalue'><input class='button' type='submit' value='Importar' /></div>
          </div>
        </div>
      </div>
      <input type='hidden' name='request_command' value='request_import' />
      </form>
      ";
      break;

   case "request_import":

      echo "<h1 class='title'>Importaci&oacute;n de Solicitudes</h1>\n";
      // Parseamos el fichero XML en un array
      $xmlData = parseXML($_FILES['csrFile']['tmp_name']);     
      // Comprobamos si ha habido algun error al hacer el parser
      if ( !$xmlData ) 
         $errorCode = "a2b1c2d2e1";
      else {
         // Obtenemos el tipo de solicitud (firma o revocacion de certificados)
         $xmlType = $xmlData[0]['xmlType'];         
         
         // Vemos cuantas solicitudes hay en el fichero
         $requestsNum = count($xmlData);

         // Para cada solicitud tendremos que generar un array y meterlo en el 
         // ldap. Empieza desde la posicion 1 de la matriz porque en la 0
         // contiene informacion del fichero en lugar de una solicitud
         for($i=1; $i < $requestsNum; $i++) {
            // Valores comunes a una CSR, RNR y una CRR
            $copaId = $xmlData[$i]['copa_id'];
            $dn = $ldapVar['rdnAttr'] . "=$copaId," . $ldapVar['base'];
            $id = $xmlData[$i]['id'];
            $requestType = $xmlData[$i]['requesttype'];
            $currentDate = date("YmdHis");
                    
            // Buscamos el numero de solicitudes que hay cuyo numero copa 
            // es $copaId
            $filter = "(".$ldapVar['rdnAttr']."=$copaId)";
            $justthese = array ("count");
            $result = ldap_get_info($ldapVar['base'], $filter, $justthese);
            if ( !$result )
	       $errorCode = "a2b1c2d1e1";
            else { 
               if ($requestType == "csr" || $requestType == "rnr") {
                  // Para poder insertar la CSR o la RNR en el ldap, tenemos que asegurarnos
                  // de que no hay ninguna otra con ese numero copa
                  if ($result['count'] != 0)
                     $errorCode = "a2b1c2d2e2"; 
                  // En este caso, preparamos los datos a importar al ldap
                  else { 
                     if ($requestType == "csr") 
                        $status = "csr-pending";
                     else
        	        $status = "rnr-pending";

                     // Preparamos los datos a importar al ldap
                     $navType = $xmlData[$i]['nav_type'];
                     $pkData = $xmlData[$i]['data'];
                     // Nos quedamos solo con la CSR del campo DATA
                     if ($navType == "SPKAC") {
                        list ($k, $pkCSR) = split("SPKAC", $pkData);
                        $pkCSR = "SPKAC" . $pkCSR;
                     }
                     else
                        $pkCSR = $pkData;
 
                     // Sacamos los demas valores de la matriz
                     $pkSubjectDN = $xmlData[$i]['subject_dn'];
                     $certType = $xmlData[$i]['ee_type'];
                     $pkShowMail = $xmlData[$i]['show_mail'];
                     $mail = $xmlData[$i]['mail'];
  
                     // Guardamos todas las trazas del XML en un array
                     $tracesNum = count($xmlData[$i]['traces']);

                     for($j = 0; $j < $tracesNum; $j++)
                        $info["pkirisTrace"][$j] = $xmlData[$i]['traces'][$j];
 
                     // Metemos todos los valores en un array para asi anyadirlos al ldap         
                     $info["objectClass"][0]="top";
                     $info["objectClass"][1]="irisObject";
                     $info["objectClass"][2]="pkirisCertificate";
                     $info[$ldapVar['rdnAttr']] = $copaId;
                     $info["pkirisID"] = $id;
                     $info["pkirisStatus"] = $status;
                     $info["pkirisDate"] = $currentDate;
                     $info["pkirisPin"] = "Only stored in the RA";
                     $info["pkirisCSR"] = $pkCSR;
                     $info["pkirisCertType"] = $certType;
                     $info["pkirisSubjectDN"] = $pkSubjectDN;
                     $info["pkirisCopaId"] = $copaId;
                     $info["pkirisShowMail"] = $pkShowMail;
                     $info["mail"] = $mail;
          
                     // Escribimos los datos en el ldap
                     $r = ldap_add_info($dn,$info);
                     if (!$r)
                        $errorCode = "a2b1c2d1e2";
                  }
               }
               else if ($requestType == "crr") {
                  // Si no hay ningun certificado con ese numero copa no podremos 
                  // llevar a cabo la revocacion
                  if ($result["count"] == 0)
                     $errorCode = "a2b1c2d2e3";
                  // El caso de que si exista el certificado, guardamos el motivo
                  // de revocacion en la misma entrada
                  else {
                     $lastStatus = getStatus($copaId);
                     if ( !$lastStatus )
                        $errorCode = "a2b1c2d2e4";
                     else {
                        $status = "crr-pending";
                 
                        // Nos aseguramos de que no se haya tratado la CRR anteriormente 
                        if ($lastStatus == $status) 
		           $errorCode = "a2b1c2d2e2";
			else {
                           // Valores propios de una CRR
                           $revReason = $xmlData[$i]['reason'];
                           $revokedBy = $xmlData[$i]['revoked_by'];
                    
                           // Creamos el array con los datos a insertar en el ldap
                           $info["pkirisStatus"] = $status;
                           $info["pkirisDate"] = $currentDate;
                           $info["pkirisRevocationReason"] = $revReason;
                           $info["pkirisRevokedByCopaID"] = $revokedBy;
                     
                           $r = ldap_mod_info($dn,$info);
                           if ( !$r ) 
                              $errorCode = "a2b1c2d1e3";
                           else {
                              // Valores necesarios para generar la traza de una revocacion
                              $traceVals["revocationReason"] = $revReason;
                              $traceVals["invalidityDate"] = $currentDate;
                           }
                        }
                     }
                  }
               }
               // Si no ha habido errores, creamos la traza e insertamos
               // la informacion en el ldap
               if ( $errorCode == "a0" ) {
                  // Generamos la nueva traza
                  $traceVals["status"] = $status;
                  $traceVals["copa"] = $copaId;
                  $traceVals["currentDate"] = $currentDate;

                  $pkiTrace = getTrace($traceVals);
                  if ( !$pkiTrace )
                     $errorCode = "a2b1c2d2e5";
                  else {
                     $urn["pkirisTrace"] = $pkiTrace;
                     $r = ldap_mod_add_info($dn,$urn);
                     if (!$r)
                        $errorCode = "a2b1c2d1e4";
                     else {
                        // Escribimos en el fichero de log los cambios de estado realizados
                        $pkiLog['status'] = $status;
                        $pkiLog['eee'] = $copaId;
                        $pkiLog['user'] = "CA-Admin";
                        $pkiLog['error'] = $errorCode;
                        writeLog ($pkiLog);
                     }
                  }
               }
            }
         } //for
         if ( $errorCode == "a0" )
            echo "<p>La importaci&oacute;n se ha realizado con &eacute;xito.</p>";
      }
   break; 
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2> Error Importando las Solicitudes </h2>
         <p>No se ha podido completar la importaci&oacute;n de todas las solicitudes.</p>\n";
   $pkiLog['status'] = $status;
   $pkiLog['eee'] = $copaId;
   $pkiLog['user'] = "CA-Admin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();

?>

